import network
import socket
import time

from machine import Pin

ssid = '***'
password = '***'

users = {
      "sdraeger": {
          "password":"draeger"
      },
      "mmustermann": {
          "password":"mustermann"
      }
    }

htmlPage = '<!DOCTYPE html><html><head><title>Raspberry Pi Pico W</title><link rel="stylesheet" type="text/css" href="http://progs.ressourcen-draeger-it.de/raspberrypipicow/login/css/style.css"/><script src="http://progs.ressourcen-draeger-it.de/raspberrypipicow/login/js/jquery-3.6.3.min.js"></script><script src="http://progs.ressourcen-draeger-it.de/raspberrypipicow/login/js/functions.js"></script></head><script> var serverIp= "{serverIp}";</script><body><div class="outer"><h2>Anmelden</h2><center><input type="text" id="inpUsername" name="inpUsername" placeholder="Benutzername"></input><br/><br/><input type="text" id="inpPassword" name="inpPassword" placeholder="Passwort"></input><br/><br/><input type="button" id="loginBtn" value="Login"/></center><br><div class="messages">{messages}</div></div></body></html>'
loggedInPage = "<!DOCTYPE html><html><head><title>Raspberry Pi Pico W</title><link rel='stylesheet' type='text/css' href='http://progs.ressourcen-draeger-it.de/raspberrypipicow/login/css/style.css'/></head><body><h1>Hallo {username}</h1><br/></body></html>"

wlan = network.WLAN(network.STA_IF)
wlan.active(True)
wlan.connect(ssid, password)

html = '<!DOCTYPE html><html><head><title>Raspberry Pi Pico W</title></head><body><h1>Hello World!</h1></body></html>'
print('waiting for connection...')
max_wait = 10
while max_wait > 0:
    if wlan.status() < 0 or wlan.status() >= 3:
        break
    max_wait -= 1
    print('.', end='')
    time.sleep(1)

print('')

if wlan.status() != 3:
    raise RuntimeError('network connection failed')
else:
    print('connected')
    status = wlan.ifconfig()
    print('ip = ' + status[0])

addr = socket.getaddrinfo('0.0.0.0', 80)[0][-1]

s = socket.socket()
s.bind(addr)
s.listen(1)

print('listening on', addr)

while True:
    try:
        cl, addr = s.accept()
        print('client connected from', addr)
        request = cl.recv(1024)
        request = str(request)
        
        print(request)
        
        params = request[8:request.find(' HTTP')]
        
        serverIpAdress = status[0]
        messages = []
        
        loginOk = False
        
        cl.send('HTTP/1.0 200 OK\r\nContent-type: text/html\r\n\r\n')  
        
        if "username" in params and "password" in params:           
            values = params.split("&")
            username = values[0].split("=")[1]
            password = values[1].split("=")[1]
            
            if username in users:
               messages.append("user found")
                
               if users[username]["password"] ==password:
                  messages.append("login OK")
                  loginOk = True
               else:
                  messages.append("login fail")
                
            else:
               messages.append("user not found")
            
        if loginOk:
            cl.send(loggedInPage.format(username=username))
        else:
            
            if messages:
                loginMessages = messages
            else:
                loginMessages = ""
             
            cl.send(htmlPage.format(serverIp=serverIpAdress, messages=loginMessages))
                       
        cl.close()

    except OSError as e:
        cl.close()
        print('connection closed')
